#include "noisecreatetemplate.h"
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "common.h"



NOISEcreateTemplate::NOISEcreateTemplate(QWidget *parent) :
    QMainWindow(parent)
{


}



void MainWindow::NOISEcreateTemplate()
{
try {

        qDebug("NOISEcreateTemplate START [%s][%d]\n" , __FILE__, __LINE__ );


        double radius     = ui->nois_radius->value();    //距離
        double elvfrom    = ui->nois_elevation->value(); //仰角開始
        double azifrom    = ui->nois_azimuth->value();   //方位角



        // 一時ディレクトリを生成
        boost::filesystem::path temp_dir = CreateTemporaryDirectory();
        boost::filesystem::path hark_config_file_path = temp_dir / "NoiseLocationFile.xml";


        qDebug("*---------------------------------------------------------*\n");
        qDebug( "harktool4_cui \n "
                    "--mode template \n"
                    "--output-file %s \n"
                    "--output-format xml \n"
                    "--output-type noise \n"
                    "--azifrom %f --aziint 0 --numazi 1 \n"
                    "--elvfrom %f --elvint 0 --numelv 1 \n"
                    "--radius NoiseLocationFile.xml"
                , "NoiseLocationFile.xml"
                , azifrom
                , elvfrom);
        qDebug("*---------------------------------------------------------*\n");




        // NoiseLocationFileを作成
         int ret = 0;
         ret = ::system((boost::format("harktool4_cui "
                        "--mode template "
                        "--output-file %s "
                        "--output-format xml "
                        "--output-type noise "
                        "--azifrom %f --aziint 0 --numazi 1 "
                        "--elvfrom %f --elvint 0 --numelv 1 "
                        "--radius %f "
                        )
                    % hark_config_file_path
                    % azifrom
                    % elvfrom
                    % radius).str().c_str());


         qDebug() << __func__ << "system(harktool4_cui)=" << ret;

         //----------------------------------------------------------------//
        // 作成したテンプレートを読み込む
        //----------------------------------------------------------------//
        ret = ::system((boost::format("tidy -o %s -xml -utf8 -w 255 -c -q -asxml -i %s ")
                                % hark_config_file_path.c_str()
                                % hark_config_file_path.c_str()).str().c_str());

        qDebug() << __func__ << "system(tidy)=" << ret;

        QFile hark_config(hark_config_file_path.c_str());

        if (!hark_config.open(QIODevice::ReadOnly))
        {
            THROW_CRITICAL(trUtf8("作成したファイルを読み込めませんでした"));
        }

        QTextStream inbuf(&hark_config);
        QString outbuf = inbuf.readAll();
        qDebug() << outbuf;
        ui->noise_textEdit->setStyleSheet(" color: white;font: bold 16px;");
        ui->noise_textEdit->setText(outbuf);
        qDebug() << "harktool4_cui Ok" ;


        //-----------------------------------------------------------------//
        // hark_config_file_pathを格納する
        //-----------------------------------------------------------------//
        m_plotctl[m_out_page_no].noise_hark_path = hark_config_file_path;


    }
    catch (std::exception& exp)
    {
        THROW_CRITICAL(exp.what());
        return;
    }

    return;
}




